// midi_in_test.ino
// version 2015-06-01
// Arduino MIDI tutorial
// by Staffan Melin
// http://libremusicproduction.com/

// libraries

#include <SoftwareSerial.h>

// We will use the SoftwareSerial library instead of the Serial library, as this will let us control which pins our MIDI interface is connected to.
SoftwareSerial mySerial(2, 3); // RX, TX

// constants

const byte midiNoteOn = 144;

const int midiSendDelay = 100; // give MIDI-device a short time to "digest" MIDI messages

#define PIN_LED 13

#define MIDI_NOTE_ON 144

byte midiByte;
byte midiChannel;
byte midiCommand;

void setup() {
	// setup SoftSerial for MIDI control
	mySerial.begin(31250);
	delay(midiSendDelay);

	pinMode(PIN_LED, OUTPUT);
}



void loop () {

	// Is there any MIDI waiting to be read?

	if (mySerial.available() > 0) {

		// read MIDI byte

		midiByte = mySerial.read();
	
		// remove channel info
		midiChannel = midiByte & B00001111;
		midiCommand = midiByte & B11110000;

		// if it is a MIDI note on commannd, blink the LED	
		if (midiCommand == MIDI_NOTE_ON)
		{
			digitalWrite(PIN_LED, HIGH);
			delay(100);
			digitalWrite(PIN_LED, LOW);
		}
	} // mySerial.available()

} // loop
